#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <ctype.h>

#if 1
#undef assert
#define assert(x)
#endif

int N2_tot,P,Preal,discard,verybad;
int M;

#define NELEM(x) (sizeof((x))/sizeof(*(x)))

#define POCTIVCU (1)
#define LHARU (2)

char player[15][15];
size_t playerl[15];
struct a {
	char line[1500];
	int author;
	char *s;
	} a[600];


char *pref[]={
	NULL, /* 0 */
	NULL, /* 1 */
	" je poctivec", /* 2 */
	" je lhar", /* 3 */
	" rika \"", /* 4 */
	NULL, /* 5 */
	NULL, /* 6 */
	" je mene nez ", /* 7 */
	" je vice nez ", /* 8 */
	" je alespon ", /* 9 */
	};

size_t prefl[500];
int poct[20],pocts,liars;


static char *getplayer(char *str,int *plr)
{
int i;

	*plr=-1;
	for (i=0;i<P;i++) {
		if (!*player[i]) continue;
		if (memcmp(player[i],str,playerl[i]) || isalpha(str[playerl[i]]))
			continue;
		assert(*plr==-1);
		*plr=i;
		}
	assert(i<P);
	assert(*plr!=-1);
	return(str+playerl[*plr]);
}

static int evals(char *s,char **end)
{
char *e;
int plr,res,cons;
int v,v1,v2,vr;
char *aplayer;
int i; 
char *trash;
int outer;

	outer=(!end);
	if (!end) end=&trash;
	if (*s=='(') {
		v1=evals(s+1,&e);
		if (!memcmp(e,") a zaroven (",13)) {
			v2=evals(e+13,&e);
			v=v1 && v2;
			}
		else if (!memcmp(e,") nebo (",8)) {
			v2=evals(e+13,&e);
			v=v1 || v2;
			}
		else assert(0);
		assert(*e==')');
		*end=e+1;
		return(v);
		}
	if (isdigit(*s)) {
int a,b,c;
		sscanf(s,"%d+%d=%d%n",&a,&b,&c,&cons);
		*end=s+cons;
		return(a+b==c);
		}
	aplayer=getplayer(s,&plr);
	plr-=3;
	res=-1;
	for (i=1;i<NELEM(pref);i++) {
		if (memcmp(aplayer,pref[i],prefl[i])) continue;
		assert(res==-1);
		res=i;
		}
	assert(res!=-1);
	*end=aplayer+prefl[i];
	switch (res) {
		case 2:
			return(poct[plr]);
		case 3:
			return(!poct[plr]);
		case 4:
			v=evals(*end,&e);
			if (!poct[plr]) vr=!v;
			else vr=v;
			assert(*e=='"'); e++;
			if (*e=='.') {
				*end=e+1;
				return(vr);
				}
			*end=e+20;
			if (!memcmp(e," a je to opravdu tak",20)) {
				if (v && vr) return(1);
				if (!v && !vr) return(0);
				if (!outer) return(0);
				verybad=1;
				return(0);
				}
			else assert(!memcmp(e,", ale neni to pravda",20));
			if (v && !vr) return(1);
			if (!v && vr) return(0);
			if (!outer) return(0);
			verybad=1;
			return(0);
			break;
		case 7:
			assert(plr==POCTIVCU || plr==LHARU);
			sscanf(*end,"%d%n",&i,&cons);
			*end+=cons;
			if (plr==POCTIVCU) return(pocts<i);
			                   return(liars<i);
		case 8:
			assert(plr==POCTIVCU || plr==LHARU);
			sscanf(*end,"%d%n",&i,&cons);
			*end+=cons;
			if (plr==POCTIVCU) return(pocts>i);
			                   return(liars>i);
		case 9:
			assert(plr==POCTIVCU || plr==LHARU);
			sscanf(*end,"%d%n",&i,&cons);
			*end+=cons;
			if (plr==POCTIVCU) return(pocts>=i);
			                   return(liars>=i);
		default: assert(0);
		}
	assert(0);
	return(0);
}


static void resultgood(void)
{
int i;

	for (i=0;i<Preal;i++) {
		if (poct[i])
			printf("%s je poctivec.\n",player[i+3]);
		else printf("%s je lhar.\n",player[i+3]);
		}
}

static int trysearch(void)
{
int try,i,v,m;

puts("trysearch()");
	for (try=0;try<(1<<Preal);try++) {
		pocts=liars=0;
		for (i=0;i<Preal;i++) {
			if ((poct[i]=(try&(1<<i)))) pocts++;
			else liars++;
			}
		for (m=0;m<M;m++) {
			if (discard==a[m].author) continue;
			verybad=0;
			v=evals(a[m].s,NULL);
printf("EVAL is %d: %s",v,a[m].s);
			if (verybad) break; /* FIXME */
			if (!poct[a[m].author]) v=!v;
			if (!v) break;
			}
		if (m==M) {
			return(1);
			}
		}
	return(0);
}

int xyzzyl,xyzzy[15];

int main( int argc, char **argv )
{
int curno;
int i;
char *s;
int m;

  scanf("%d",&N2_tot);
  scanf("\n");
	for (i=0;i<NELEM(pref);i++) {
		if (pref[i]) prefl[i]=strlen(pref[i]);
		}
  for (curno=0;curno<N2_tot;curno++)
  {
		printf("Hra cislo %d:\n",curno+1);
		scanf("%d",&P);
		for (i=0;i<P;i++)
			scanf("%s",player[i+3]);
		Preal=P;
		P+=3;
		strcpy(player[POCTIVCU],"Poctivcu");
		strcpy(player[LHARU],"Lharu");
		for (i=0;i<NELEM(player);i++)
			playerl[i]=strlen(player[i]);
		scanf("%d\n",&M);
		for (m=0;m<M;m++) {
			fgets(a[m].line,sizeof(a[m].line),stdin);
			s=getplayer(a[m].line,&a[m].author);
			assert(!!s);
			assert(s[0]==':' && s[1]==' '); s+=2;
			a[m].s=s;
			}
		discard=-1;
		if (trysearch()) {
			resultgood();
			goto next;
			}
		xyzzyl=0;
		for (i=0;i<Preal;i++) {
			discard=i;
			if (!trysearch()) continue;
			xyzzy[xyzzyl++]=i;
			}
		if (xyzzyl==1) {
			printf("%s prohral.\n",player[xyzzy[0]+3]);
			goto next;
			}
		if (xyzzyl) {
			printf("Prohral nektery z techto hracu");
			for (i=0;i<xyzzyl;i++)
				printf("%c %s",(i?',':':'),player[xyzzy[i]+3]);
			puts(".");
			goto next;
			}
		puts("Pravidla porusilo vice hracu.");
next:
		putchar('\n');
  }
  return 0;
}
