#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

int M,N,N2,siz,dsiz;
int *a,*b,*c,*d;

static __inline__ void addline(int how)
{
int i;
	for (i=0;i<=dsiz;i++)
		c[i]+=how*d[i];
}

static __inline__ void mulbypoly(int **destp,int dlen,int *src,int slen)
{
int *cumul,mdsiz=dsiz;
int *dest=*destp;
int i,j;

	cumul=calloc(siz*sizeof(int),1);
	for (i=0;i<=slen;i++) {
		for (j=0;j<=dlen;j++) {
			if (!(cumul[i+j]+=src[i]*dest[j])) continue;
			if (i+j>mdsiz) mdsiz=i+j;
			}
		}
	free(dest);
	*destp=cumul;
	dsiz=mdsiz;
}

int main( int argc, char **argv )
{
int curno;
int i,j;
  scanf("%d",&N2);
  scanf("\n");
  for (curno=0;curno<N2;curno++)
  {
		scanf("%d%d",&M,&N);
		a=malloc(sizeof(int)*(M+1));
		siz=(M+1)*(N+1)+10;
		b=calloc(sizeof(int)*siz,1);
		c=calloc(sizeof(int)*siz,1);
		d=calloc(sizeof(int)*siz,1);
		dsiz=N;
		for (i=0;i<=M;i++)
			scanf("%d",a+i);
		for (i=0;i<=N;i++)
			scanf("%d",b+i);
		memcpy(d,b,sizeof(int)*siz);
		c[0]=a[0];
		for (i=1;i<=M;i++) {
			if (a[i]) addline(a[i]);
			mulbypoly(&d,dsiz,b,N);
			}
		for (i=dsiz;i>=0;i--)
			if (c[i]) break;
		for (j=0;j<=i;j++) {
			if (j) putchar(' ');
			printf("%d",c[j]);
			}
		putchar('\n');
		free(a);
		free(b);
		free(c);
  }
  return 0;
}
