#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

int N,R,S,RS;
int *ar,*posx,*posy;
#define AR(x,y) ar[(y)*S+(x)]
int i,j,k;

static __inline__ void setone(int x,int y,int val)
{
	AR(x,y)=val;
	posx[val]=x;
	posy[val]=y;
}

static __inline__ int getxy(int x,int y)
{
	if (x<0 || x>=S || y<0 || y>=R) return(-1);
	return(AR(x,y));
}

static void move(int what)
{
int x=posx[what],y=posy[what],x1,y1;

	     if (!getxy((x1=x+1),(y1=y+0)))
		printf("Kamen %d presunut doprava.\n",what);
	else if (!getxy((x1=x-1),(y1=y+0)))
		printf("Kamen %d presunut doleva.\n",what);
	else if (!getxy((x1=x),(y1=y+1)))
		printf("Kamen %d presunut dolu.\n",what);
	else if (!getxy((x1=x),(y1=y-1)))
		printf("Kamen %d presunut nahoru.\n",what);
	else {
		printf("Neplatny tah kamenem %d.\n",what);
		return;
		}
	setone(x1,y1,what);
	setone(x,y,0);
}

int main( int argc, char **argv )
{
int inp,x,y,curno;
  scanf("%d",&N);
  scanf("\n");
  for (curno=0;curno<N;curno++)
  {
		printf("Skladacka cislo %d:\n",curno+1);
		scanf("%d%d",&R,&S);
		ar=malloc(sizeof(int)*(RS=R*S+100));
		posx=malloc(sizeof(int)*RS);
		posy=malloc(sizeof(int)*RS);
		for (y=0;y<R;y++)
		for (x=0;x<S;x++)
			{
			scanf("%d",&inp);
			setone(x,y,inp);
			}
		for (;;) {
			scanf("%d",&inp);
			if (inp==0) break;
			move(inp);
			}
		for (y=0;y<R;y++)
		for (x=0;x<S;x++)
			{
			if (x) putchar(' ');
			printf("%d",AR(x,y));
			if (x==S-1) putchar('\n');
			}
		putchar('\n');
		free(ar);
		free(posx);
		free(posy);
  }
  return 0;
}
